/* 
 * File:   main.cpp
 * Author: manyi
 *
 * Created on May 16, 2014, 6:57 PM
 */

#include <cstdlib>
#include <string>
#include <algorithm>
#include <functional>
#include <unordered_map>
#include <iostream>
#include <fstream>
#include <sstream>
#include <utility>
#include <set>
#include <map>

using namespace std;

/*class TimeTable{
    unordered_map<string, pair<int, bool> > stations;
    set<string> newstations;
    map<int, string> notused;
public:
    TimeTable( ){
        ifstream ifs("bemenet.txt");
        if( !ifs ){
            cout<<"File open error"<<endl;
            exit( 1 );
        }
        string line;
        int n;
        ifs>>n;
        getline(ifs,line); //skip new line
        for( int i=0; i<n; ++i ){
            getline(ifs, line);
            
            stringstream ss( line );
            int code; ss>>code;
            string word, name;
            ss>>name;
            while( ss>>word){
                name.append(" "+word);
            }
            stations.insert( make_pair( name, make_pair(code,false)));
        }
        ifs.close();
        ifs.open("frissites.txt");
        while( getline(ifs, line)){
            if( line.size() < 2)continue;
            stringstream ss( line );
            string name, word;
            ss>>name;
            while( ss>>word){
                name.append(" "+word);
            }
            auto it =stations.find( name );
            if( it == stations.end() ){
                newstations.insert(  name );
            }else{
                stations[ name ].second = true;
            }
        }
    }
    
    void printNotUsed(){
        cout<<"Eltunt allomasok: "<<endl;
        for( auto it: stations ){
            if( it.second.second == false ){
                notused.insert( make_pair(it.second.first, it.first));
            }
        }
        for( auto s: notused){
            cout<<s.first<<" "<<s.second<<endl;
        }
        //cout<<"Not used: "<<notused.size()<<endl;
    }
    
    void printNewStations(){
        cout<<"\nUj allomasok: "<<newstations.size()<<endl;
        for( auto i: newstations){
            cout<<i<<endl;
        }
    }  
};
*/

struct elem{
    int id;
    string station;
    bool state;
    elem( int id, string station, bool state=false): id(id), station( station){}
};

bool compStationNames( const elem& e1, const elem& e2){
    return  e1.station < e2.station;
}

bool compStationIds( const elem& e1, const elem& e2){
    return  e1.id < e2.id;
}


class TimeTable{
    vector<elem> stations;
    set<string> newstations;
    vector<elem> notused;
public:
    TimeTable( ){
        ifstream ifs("bemenet.txt");
        if( !ifs ){
            cout<<"File open error"<<endl;
            exit( 1 );
        }
        string line;
        int n;
        ifs>>n;
        getline(ifs,line); //skip new line
        for( int i=0; i<n; ++i ){
            getline(ifs, line);
            
            stringstream ss( line );
            int code; ss>>code;
            string word, name;
            ss>>name;
            while( ss>>word){
                name.append(" "+word);
            }
            stations.push_back( elem(code, name));
        }
        sort( stations.begin(), stations.end(), compStationNames);
        ifs.close();
        ifs.open("frissites.txt");
        while( getline(ifs, line)){
            if( line.size() < 2)continue;
            stringstream ss( line );
            string name, word;
            ss>>name;
            while( ss>>word){
                name.append(" "+word);
            }
            
            typedef vector<elem>::iterator ITER;
            pair<ITER, ITER> p = equal_range(stations.begin(), stations.end(),  elem(0, name), compStationNames );
            if( p.first->station == name){
                p.first->state = true;
                
            }else{
                newstations.insert( name );
            }
        }
    }
    
    void printNotUsed(){
        cout<<"Eltunt allomasok: "<<endl;
        for( auto& station: stations ){
            if( station.state == false ){
                notused.push_back( station );
            }
        }
        sort( notused.begin(), notused.end(), compStationIds);
        
        for( auto& s: notused){
            cout<<s.id<<" "<<s.station<<endl;
        }
       
    }
    
    void printNewStations(){
        cout<<"\nUj allomasok: "<<endl;
        for( auto& i: newstations){
            cout<<i<<endl;
        }
    }
    
    
};


int main(int argc, char** argv) {
    set<string, greater<string> > be;
    set<int> ids;
    ifstream ifs("be.txt");
    string line;
    while( ifs >> line ){
        be.insert(line);
    }
    cout<<"SIZE: "<<be.size()<<endl;
//    ofstream ofs("bemenet.txt");
//    ofs<<be.size()<<endl;
//    for( const string& s: be ){
//        while( true ){
//            int r = rand() % 1000;
//            if( ids.find(r) == ids.end()){
//                ofs<<r<<"\t"<<s<<endl;
//                break;
//            }
//        }
//    }
    
//    ofstream ofs("frissites.txt");
//    int counter = 0;
//    for( const string& s: be ){
//        if( counter <90 ){
//            ofs<<s<<endl;
//            if( counter %10 == 0) {
//                ofs<<s<<endl;
//            } 
//            if( counter % 20 == 0 ){
//                ofs<<"STATION"<<counter<<endl;
//            }
//            ++counter;
//        }
//    }
    
   TimeTable tt;
   tt.printNotUsed();
   tt.printNewStations();
    /*ifstream ifs("F.IN");
    ofstream ofs1("bemenet.txt");
    ofstream ofs2("frissites.txt");
    string line;
    for( int i=0; i<=80000; ++i){
        getline(ifs, line);
        ofs1<<line<<endl;
    }
    getline(ifs, line);
    while( getline(ifs, line)){
        ofs2<<line<<endl;
    }
     * */
    return 0;
}

